def filter[T](func: T => Boolean, list: List[T]): List[T] = {
  list match {
    case Nil => Nil
    case e::rest if func(e) => e::filter(func, rest)
    case _::rest => filter(func, rest)
  }
}

def partition[T](func: T => Boolean, list: List[T]): (List[T], List[T]) = {
  list match {
    case Nil => (List.empty[T], List.empty[T])
    case e::rest => {
      val part = partition(func, rest)
      if (func(e)) {
        (e::part._1, part._2)
      } else {
        (part._1, e::part._2)
      }
    }
  }
}

def partition[T](func: T => Boolean, list: List[T]): (List[T], List[T]) = {
  list.foldRight((List.empty[T], List.empty[T]))(
    (e: T, prev: (List[T], List[T])) => {
      if (func(e)) {
        (e::prev._1, prev._2)
      } else {
        (prev._1, e::prev._2)
      }
    }
  )
}


val b = (1 to 10).toList

filter((x: Int) => x % 2 == 0, b)

partition((x: Int) => x % 2 == 0, b)
